# $Id: ruby-CorporateTime.spec,v 1.41 2004/12/14 03:36:01 ianmacd Exp $
#

Summary: Ruby interface to Steltor/Oracle's CorporateTime calendar server
Name: ruby-CorporateTime
Version: 0.4.1
Release: 1
License: GPL
Group: Applications/Ruby
Source: http://www.caliban.org/files/ruby/%{name}-%{version}.tar.gz
URL: http://www.caliban.org/ruby/
Packager: Ian Macdonald <ian@caliban.org>
BuildRoot: /var/tmp/%{name}-%{version}
BuildRequires: ruby
Requires: ruby >= 1.8.0
# don't want rpm to complain at install time about missing CAPI library
Provides: libcapi.so

%description
CorporateTime is a corporate calendar server product originally produced by
Steltor and now sold by Oracle.

Ruby/CorporateTime is a Ruby language extension that serves as a wrapper to
the CorporateTime API known as CAPI. It allows interaction with CorporateTime
servers via the Ruby programming language.

In order to use this software, you should have the Calendar API (CAPI)
software installed on your computer.

%prep
%setup

%build
ruby extconf.rb \
  --with-capi-include='/usr/include/capi:/usr/local/include/capi' \
  --with-capi-lib='/usr/lib/capi:/usr/local/lib/capi'
make
#make docs

%clean
rm -rf $RPM_BUILD_ROOT

%install
rm -rf $RPM_BUILD_ROOT

strip ctime.so

make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -d $RPM_BUILD_ROOT%{_mandir}/man3
install example/mycal $RPM_BUILD_ROOT%{_bindir}

install doc/corptime.3 $RPM_BUILD_ROOT%{_mandir}/man3/corptime.3
gzip -9 $RPM_BUILD_ROOT%{_mandir}/man3/corptime.3

find $RPM_BUILD_ROOT -type f -print | \
    ruby -pe 'sub(%r(^'$RPM_BUILD_ROOT'), "")' > %{name}-%{version}-filelist

%files -f %{name}-%{version}-filelist
%defattr(-,root,root)
%doc CHANGES COPYING INSTALL README TODO
%doc example/*
%doc doc/ctime.html doc/ctime.rd

%changelog
* Mon Dec 13 2004 Ian Macdonald <ian@caliban.org> 0.4.1-1
- 0.4.1
- CTime#connect, CTime#open_agenda, CTime::Agenda#get_event and
  CTime::Agenda#get_events can now be called with an optional block.

* Thu Dec  9 2004 Ian Macdonald <ian@caliban.org> 0.4.0-1
- 0.4.0
- An exception is now thrown when CTime#quit is called multiple times.
- A check is now performed to ensure that the parameter passed to
  CTime::Agenda#get_event is actually a string.
- It's now possible to call CTime.new to instantiate a CTime object without
  actually connecting to a server. For compatibility with previous versions,
  you can still pass 3 parameters, in which case they will be silently passed
  to the new CTime#connect method.
- The CTimeError exception class has been renamed CAPIError. When CTime#connect
  raises a a CAPIError, the exception message is now much more specific about
  why the connection attempt failed.
- When CTime#designate fails, we now raise a DesignationError, not a
  CAPIError/CTimeError. We also raise a DesignationError when attempting to
  designate to an unknown user. The previous UnknownUserError exception has
  been dropped.
- CTime objects no longer have @agendas attribute to track open agendas.  This
  is no longer needed, because CTime#connect returns a CTime::Agenda object.
  Logically, this has resulted in the removal of CTime#close_agenda, which has
  been replaced by CTime::Agenda#close.
- Other methods that logically relate to an agenda but operated on CTime
  objects now have a CTime::Agenda object as their receiver. These are
  CTime::Agenda#set_event, CTime::Agenda#delete_event, CTime::Agenda#get_event
  and CTime::Agenda#get_events.
- CTime objects no longer have an @error attribute for tracking the status of
  the most recently attempted operation. Instead, an exception will be raised
  whenever something bad happens.
- CTime objects no longer have a @capabilities attribute. Instead,
  CTime#capabilities has been implemented.
- A new command line option, -c|--calendar, was added to the mycal example
  program for viewing someone else's agenda.

* Sat Nov 20 2004 Ian Macdonald <ian@caliban.org> 0.3.4-1
- 0.3.4
- CTime#get_event has now been implemented. This takes a UID and returns an
  Array of Event objects associated with that UID. 
- A new command line option, -i|--ics, was added to the mycal example program
  to allow the dumping of events as raw iCalendar data.

* Fri Nov 11 2004 Ian Macdonald <ian@caliban.org> 0.3.3-1
- 0.3.3
- When Event objects were initialised, the start_time attribute was not
  correctly being converted to UTC when used by CTime#set_event.
- Commas in the location, summary and description attributes of Event objects
  are now escaped with a backslash. Otherwise, the server will complain when
  passed such an object by CTime#set_event.

* Sun Nov  7 2004 Ian Macdonald <ian@caliban.org> 0.3.2-1
- 0.3.2
- Start and end time parameters to CTime#get_events may now be of any class
  that responds to the strftime method, or a String. The same applies to the
  start time parameter passed to Event.new.
- Start and end time parameters to CTime#get_events are now automatically
  converted to UTC, if they respond to either the gmtime or new_offset methods.
  The same applies to the start time parameter passed to Event.new.
- The example programs have been updated and simplified to reflect these
  changes.

* Tue Nov  2 2004 Ian Macdonald <ian@caliban.org> 0.3.1-1
- 0.3.1
- Event objects now have a new attribute, @ics, which contains the raw
  iCalendar stream for that object.
- Fixed UTF-8 to Latin 1 conversion.
- Event#inspect is now Event#to_s. Event#inspect has been rewritten to return
  the raw iCalendar stream for the associated event.
- Documentation updates.

* Mon Nov  1 2004 Ian Macdonald <ian@caliban.org> 0.3.0-1
- 0.3.0
- Ignore alarms when parsing events. Specifically, their description would
  overwrite the event's description.
- CTime#get_events now takes an optional third parameter. If set to false,
  the raw iCal stream will be returned instead of an array of event objects.
- Event object values are now converted from UTF-8 to Latin 1.

* Tue Sep 21 2004 Ian Macdonald <ian@caliban.org> 0.2.3-1
- 0.2.3
- event setting was still broken

* Wed May 26 2004 Kevin McCarthy <kjm@google.com> 0.2.2-1
- 0.2.2
- event setting, broken in 0.2.0, has been fixed

* Wed May 12 2004 Kevin McCarthy <kjm@google.com> 0.2.1-1
- 0.2.1
- fixed the event parser to handle DATE values. It returns start_time and
  end_time at the beginning/end of the day in localtime. Also fixed the case
  for a missing end_time, which is actually legal.
- event description and summary are now unescaped during parsing.

* Tue Apr 20 2004 Kevin McCarthy <kjm@google.com> 0.2.0-1
- 0.2.0
- added a compatibility layer to work with different versions of the CAPI.
- wrapped the CAPIHandle object in the Agenda object returned by
  ct_open_agenda. The Agenda object should now be passed to close_agenda.
- fixed a bug in close_agenda to pass in a (CAPIHandle *) instead of
  CAPIHandle.
- eliminated the second fetch attempt (with fewer attributes) in
  ct_get_events. The server will return all attributes it can, there's no need
  to requery.
- created new 'Event' and 'Attendee' classes. Moved iCal parsing into the
  Event class.

* Thu Nov 12 2003 Ian Macdonald <ian@caliban.org> 0.1.4-1
- 0.1.4
- when using Ruby 1.8.0, a warning would be issued when instantiating a
  CTime object

* Wed Mar  5 2003 Ian Macdonald <ian@caliban.org> 0.1.3-1
- 0.1.3
- now works with CAPI 2.5.1
- CTime#get_events is back to taking two parameters, not three
- CTime::Event objects now have the extra attribute @end, since CAPI 2.5.1
  returns the end time of an event, not the duration. CAPI 2.0 does the
  opposite
- all-day events are now somewhat handled in CTime#get_events
- fixed bug whereby calendar stream was destroyed before parsing
- more legible debug output

* Tue Jan  7 2003 Ian Macdonald <ian@caliban.org> 0.1.2-1
- 0.1.2
- CTime#get_events now takes a third parameter that specifies the type
  of property list to attempt to retrieve

* Thu Oct  2 2002 Ian Macdonald <ian@caliban.org> 0.1.1-1
- 0.1.1
- ct_get_events() now decodes quoted printable MIME in events

* Wed Sep 25 2002 Ian Macdonald <ian@caliban.org> 0.1.0-1
- 0.1.0
